#include <sys/types.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <unistd.h>

int main(int argc, char* argv[]) {
    int fd, size;
    void *ptr;

    if (argc != 2) return 1;

    fd = open(argv[1], O_RDONLY, 0);
    if (fd == -1) return 1;

    size = lseek(fd, 0, SEEK_END);
    lseek(fd, 0, SEEK_SET);
    size = (size & ~4095) + 4096;

    ptr = mmap(NULL, size, PROT_READ|PROT_WRITE|PROT_EXEC,
               MAP_FIXED|MAP_PRIVATE, fd, 0);
    if (ptr != NULL) return 1;

    asm("xorl %eax, %eax;\n"
        "xorl %ebx, %ebx;\n"
        "xorl %ecx, %ecx;\n"
        "xorl %edx, %edx;\n"
        "xorl %esi, %esi;\n"
        "xorl %edi, %edi;\n"
        "xorl %ebp, %ebp;\n"
        "jmp *%eax;\n");

    return 0;
}
